
C.........................................................................
C Version "%W% %P% %G% %U%"
C EDSS/Models-3 I/O API.  Portions copyright (C) 1992-1997 MCNC
C See file "COPYRIGHT.txt" for conditions of use.
C.........................................................................

        INTEGER FUNCTION JSTEP3( JDATE, JTIME, SDATE, STIME, TSTEP )

C
C JEB FOR DLL COMPILATION
C
!DEC$ IF DEFINED(MAKE_DLL)
!DEC$ ATTRIBUTES DLLEXPORT :: JSTEP3
!DEC$ ENDIF
C***********************************************************************
C  function body starts at line
C
C  FUNCTION:  returns the timestep-record number corresponding to JDATE:JTIME
C             for the timestep sequence starting at SDATE:STIME, with time
C             step increment TSTEP
C
C  RETURN VALUE:
C             time step record number, if successful, or  -1  if the
C             indicated  JDATE:JTIME  is not a positive multiple of
C             TSTEP from SDATE:STIME
C
C  PRECONDITIONS REQUIRED:  none
C
C  SUBROUTINES AND FUNCTIONS CALLED:  none
C
C  REVISION  HISTORY:
C             prototype 3/92 by CJC
C
C***********************************************************************

      IMPLICIT NONE

C...........   ARGUMENTS and their descriptions:

        INTEGER         JDATE   !  requested date YYYYDDD
        INTEGER         JTIME   !  requested time HHMMSS
        INTEGER         SDATE   !  starting date  YYYYDDD
        INTEGER         STIME   !  starting time  HHMMSS
        INTEGER         TSTEP   !  time step      H*MMSS


C...........   SCRATCH LOCAL VARIABLES and their descriptions:

        INTEGER         DAYS
        INTEGER         HRS
        INTEGER         MINS
        INTEGER         SECS
        INTEGER         DTIME   !  accumulated time interval( secs )
        INTEGER         DSTEP   !  time step, in secs
        INTEGER         JYEAR
        INTEGER         SYEAR


C***********************************************************************
C   begin body of function  JSTEP3

        IF ( TSTEP .LT. 0 ) THEN
            JSTEP3 = -1
        ELSE IF ( TSTEP .EQ. 0 ) THEN
            JSTEP3 = 1
        ELSE
            JYEAR = JDATE/1000
            SYEAR = SDATE/1000
            IF ( JYEAR .LT. SYEAR ) THEN
                JSTEP3 = -1
                RETURN
            END IF

            DTIME = 0   !  accumulated time interval

111         CONTINUE    !  loop adjusting DTIME for JYEAR:SYEAR difference

                IF ( JYEAR .GT. SYEAR ) THEN
                    IF ( MOD( SYEAR, 4 ) .NE. 0 ) THEN
                        SYEAR = SYEAR + 1
                        DTIME = DTIME + 365 * 86400
                    ELSE IF ( MOD( SYEAR, 100 ) .NE. 0 ) THEN
                        SYEAR = SYEAR + 1
                        DTIME = DTIME + 366 * 86400
                    ELSE IF ( MOD( SYEAR, 400 ) .NE. 0 ) THEN
                        SYEAR = SYEAR + 1
                        DTIME = DTIME + 365 * 86400
                    ELSE
                        SYEAR = SYEAR + 1
                        DTIME = DTIME + 366 * 86400
                    END IF

                    GO TO  111

                END IF          !  end loop adjusting years

            SECS  = MOD( JTIME,     100 ) - MOD( STIME,     100 )
            MINS  = MOD( JTIME/100, 100 ) - MOD( STIME/100, 100 )
            HRS   =      JTIME/10000      -      STIME/10000
            DAYS  = MOD( JDATE,    1000 ) - MOD( SDATE,    1000 )
            DTIME = DTIME +
     &              SECS + 60 * ( MINS + 60 * ( HRS + 24 * DAYS ) )

            SECS  = MOD( TSTEP,     100 )
            MINS  = MOD( TSTEP/100, 100 )
            HRS   =      TSTEP/10000
            DSTEP = SECS + 60 * ( MINS + 60 * HRS )

            IF ( DTIME .LT. 0 ) THEN
                JSTEP3 = -1
            ELSE IF ( MOD( DTIME, DSTEP ) .NE. 0 ) THEN
                JSTEP3 = -1
            ELSE
                JSTEP3 = 1  +  DTIME / DSTEP
            END IF

        END IF          !  if tstep<0, =0, or >0

        RETURN

        END

